import math

class Cerchio:

	# NON e` possibile definire due costruttori,anche se con parametri diversi!
# 	def __init__(self):
#		self.r = 1.0
	
	# costruttore
	def __init__(self, r):
		self.r = r
	
	# metodo di istanza
	# NOTA: il primo parametro deve essere self
	def area(self):
		return self.r * self.r * math.pi

	# NOTA: errore! area = 100 sovrascrive il metodo con lo stesso nome!

	# metodo di classe. Verra` invocato come Cerchio.radToDeg(3.14)
	# NOTA: manca il self come primo parametro
	def radToDeg(rads):
		return rads * 180 / math.pi

	def ingrandisci(self, fattore):
		self.r = self.r * fattore


	# perche' un metodo set? 
	# Ad esempio, per impedire che l'utente imposti un raggio negativo...
	# a quel punto, potrei rendere l'attributo raggio privato... e aggingerci
	# un metodo getR che restituisce il raggio
	def setR(self, raggio):
		if(raggio >= 0):
			self.r = raggio

	def getR(self):
		return self.r
	
	# rappresentazione dell'oggetto sottoforma di stringa
	# Invocato quando viene chiamata la print su un oggetto Cerchio.
	#
	# Esempio:
	# >>> c1 = cerchio.Cerchio(2)
	# >>> print(c1)
	# Cerchio di raggio2
	#
	def __repr__(self):
		return "Cerchio di raggio" + str(self.r)

	# --------------------------------------------------------
	# Overloading operatori
	#
	# > (greater than, gt):
	# returns true if self is greater than other
	def __gt__(self, other):
		return self.r > other.r

	def __ge__(self, other):
		return self.r >= other.r
	# == equality between self and other
	#
	def __eq__(self, other):
		return self.r == other.r

# Cerchio nel piano cartesiano
class PlaneCircle(Cerchio):

	# costruttore di un cerchio posizionato nel piano cartesiano
	# NOTA: per inizializzare correttamente il cerchio, chiamo
	# la __init__ di Cerchio con il raggio come parametro.
	#
	def __init__(self, raggio, x, y):
		self.x  = x
		self.y = y
		# inizializzo il raggio chiamando l'implementazione del metodo __init__ della
		# classe base.
		#
		Cerchio.__init__(self, raggio)

	def getPos(self):
		return self.x, self.y

	# attributi della classe: posizione nel piano cartesiano
	x = 0
	y = 0


	
